/*
   Calculate the absolute values of a float array's elements.
 */

#include <stdlib.h>
#include <stdio.h>

#include <altivec.h>

#include "data.h"

void vabs(float *input, float *output, int num)
{
	int i;

	vector float *vinput = (vector float *)input;
	vector float *voutput = (vector float *)output;

	vector float vzero = {0, 0, 0, 0};

	for (i = 0; i < num / 4; i++) {
		vector bool int is_neg = vec_cmpgt(vzero, vinput[i]);
		vector float negated = vec_sub(vzero, vinput[i]);

		voutput[i] = vec_sel(vinput[i], negated, is_neg);
	}
	for (i = i * 4; i < num; i++) {
		output[i] = 0 > input[i] ? -input[i] : input[i];
	}
}

int main(int argc, char *argv[])
{
	int i;
	float output[data_len];

	for (i = 0; i < data_len; i += 3) {
		data[i] = -data[i];
	}

	vabs(data, output, data_len) ;

	printf("output = {");
	for (i = 0; i < data_len; i++) {
		printf("%f, ", output[i]);
	}
	printf("};\n");
	return 0;
}
