/*
   Calculate the (float) average of an integer array's elements 
 */

#include <stdlib.h>
#include <stdio.h>

#define OVERRIDE_DATA_T int
#include <altivec.h>

#include "data.h"

float avg(int *input, int num)
{
	int i;
	float res;
	float scale = 1.0 / num;
	vector float vres   = {0, 0, 0, 0};
	vector float vscale = {scale, scale, scale, scale};

	for (i = 0; i < num - 4; i += 4) {
	    vector int *current = ((vector int *)&input[i]);
		vector float fcurrent = vec_ctf(*current, 0);

	    vres = vec_add(vres, vec_mul(fcurrent, vscale));
	}
	res = vres[0] + vres[1] + vres[2] + vres[3];
	for (; i < num; i++) {
	    res += input[i] * scale;
	}
	return res;
}

int main(int argc, char *argv[])
{
	printf("avg = %f\n", avg(data, data_len));
	return 0;
}
