/*
   Scale a float array's elements by a constant factor.
   Version 1: Cast to vector pointer.
   Check cc -S and compare assembly.
 */

#include <stdlib.h>
#include <stdio.h>

#include <altivec.h>

#include "data.h"

void scale(float *input, int num, float scale)
{
	int i;
	vector float vscale = {scale, scale, scale, scale};
	for (i = 0; i < num - 4; i += 4) {
	    vector float *current = ((vector float *)&input[i]);
	    *current = vec_mul(vscale, *current);
	}
	for (; i < num; i++) {
	    input[i] = scale * input[i];
	}
}

int main(int argc, char *argv[])
{
	int i;

	scale(data, data_len, 0.5);

	printf("res = {");
	for (i = 0; i < data_len; i++) {
		printf("%f, ", data[i]);
	}
	printf("};\n");
	return 0;
}
