/*
	Interleaving both input arrays results in higher
	cache locality and better performance.
 */

#include "n.h"
#include <altivec.h>

struct point2d {
	float a;
	float b;
};

struct point2d input[n];
float c[n];

int main()
{
	int i;
	vector unsigned char pata = {0x00, 0x01, 0x02, 0x03,
								 0x08, 0x09, 0x0a, 0x0b,
								 0x10, 0x11, 0x12, 0x13,
								 0x18, 0x19, 0x1a, 0x1b};

	vector unsigned char patb = {0x04, 0x05, 0x06, 0x07,
								 0x0c, 0x0d, 0x0e, 0x0f,
								 0x14, 0x15, 0x16, 0x17,
								 0x1c, 0x1d, 0x1e, 0x1f};

	vector float *vinput = (vector float *)input;
	vector float *vc = (vector float *)c;

	for (i = 0; i < n / 4; i++) {
		vector float vi  = vinput[2 * i];
		vector float vi1 = vinput[2 * i + 1];

		vc[i] = vec_add(
				  vec_perm(vi, vi1, pata),
				  vec_perm(vi, vi1, patb)
			);
	}
	return 0;
}

